"use client";
import { useRef, useState } from "react";
import { ChevronLeft, ChevronRight, Star } from "@mui/icons-material";
import { Divider, IconButton } from "@mui/material";
import { Swiper, SwiperSlide } from "swiper/react";

import { Grid } from "swiper/modules";

import "swiper/css/grid";
import UserCommentCard from "../common/cards/UserCommentCard";
import ProductSection from "../sections/ProductSection";

const UserComments = ({ hidden = false, section }) => {
  //* swiper controller
  const swiperRef = useRef(null);
  const [isBeginning, setIsBeginning] = useState(true);
  const [isEnd, setIsEnd] = useState(false);

  const handleNext = () => {
    if (swiperRef.current && !isEnd) {
      swiperRef.current.swiper.slideNext();
    }
  };

  const handlePrev = () => {
    if (swiperRef.current && !isBeginning) {
      swiperRef.current.swiper.slidePrev();
    }
  };

  const handleSlideChange = (swiper) => {
    setIsBeginning(swiper.isBeginning);
    setIsEnd(swiper.isEnd);
  };

  const calScore = (comments) => {
    let score = 0;
    let length = 0;
    if (comments && comments.length > 0) {
      comments.map((item) => {
        score += Number(item.score);
        length += 1;
      });
      const result = Number((score / length).toFixed(1));
      return result;
    } else {
      return 5;
    }
  };
  return (
    <ProductSection hidden={hidden} section={section} id="comments">
      {/* <div className="w-full flex flex-col gap-6">
        <div className="w-full flex flex-col gap-4 ">
          <div className="w-full flex items-center gap-4">
            <p>{section?.content?.length} نظر</p>
            <Divider orientation="vertical" />
            <div className="flex items-center gap-1">
              <Star sx={{ color: "#EAB208" }} />
              <span className="font-bold">{calScore(section?.content)}</span>
              <p>از</p>
              <p>5</p>
            </div>
          </div>
          <div className="item-grid h-[418px] ">
            <Swiper
              ref={swiperRef}
              onSlideChange={handleSlideChange}
              className="comment-swiper"
              direction="horizontal"
              spaceBetween={16}
              style={{ width: "100%", height: "100%", maxWidth: "100%" }}
              slidesPerView={"auto"}
              modules={[Grid]}
              grid={{
                rows: 2,
              }}
            >
              {section?.content?.map((item, index) => (
                <SwiperSlide
                  className="comment-swiper-slide"
                  key={index.toString()}
                >
                  <UserCommentCard comment={item} />
                </SwiperSlide>
              ))}
            </Swiper>
          </div>
          <div className="w-full flex items-center justify-between">
            <IconButton disabled={isBeginning} onClick={handlePrev}>
              <ChevronRight />
            </IconButton>

            <IconButton onClick={handleNext} disabled={isEnd}>
              <ChevronLeft />
            </IconButton>
          </div>
        </div>
      </div> */}
    </ProductSection>
  );
};

export default UserComments;
